New Protocols Using TLS Must Require TLS 1.3
RFC 9852
BCP 195
Rich Salz
Akamai Technologies
rsalz@akamai.com
Nimrod Aviram
nimrod.aviram@gmail.com
January 2026
Security
Using TLS in Applications
TLS
TLS Transition
TLS Support
Interoperability
features
TLS 1.3 is widely used, has had comprehensive security proofs, and improves both security and privacy deficiencies in TLS 1.2. Therefore, new protocols that use TLS must require TLS 1.3. As DTLS 1.3 is not widely available or deployed, this prescription does not pertain to DTLS (in any DTLS version); it pertains to TLS only.
This document updates RFC 9325. It discusses post-quantum cryptography and the security and privacy improvements in TLS 1.3 as the rationale for the update.
Introduction
This document specifies that new protocols that use TLS must assume that TLS 1.3 is available and require its use. As DTLS 1.3 is not widely available or deployed, this prescription does not pertain to DTLS (in any DTLS version); it pertains to TLS only.
TLS 1.3 [RFC9846] is in widespread use and fixes most known deficiencies with TLS 1.2. Examples of this include encrypting more of the traffic so that it is not readable by outsiders and removing most cryptographic primitives now considered weak. Importantly, the protocol has had comprehensive security proofs and should provide excellent security without any additional configuration.
TLS 1.2 [RFC5246] is in use and can be configured such that it provides good security properties. However, TLS 1.2 suffers from several deficiencies, as described in Section 6. Addressing them usually requires bespoke configuration.
This document updates [RFC9325]. It discusses post-quantum cryptography and the security and privacy improvements in TLS 1.3 as the rationale for the update. See Section 5.
Conventions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Implications for Post-Quantum Cryptography (PQC)
Cryptographically Relevant Quantum Computers (CRQCs), once available, will have a huge impact on TLS traffic (see, e.g., Section 3 of [I-D.ietf-pquip-pqc-engineers]). To mitigate this, TLS applications will need to migrate to Post-Quantum Cryptography (PQC) [PQC]. Detailed considerations of when an application requires PQC or when a CRQC is a threat that an application needs to protect against are beyond the scope of this document.
It is important to note that the TLS Working Group is focusing its efforts on TLS 1.3 or later; TLS 1.2 will not be supported (see [RFC9851]). This is one more reason for new protocols to require TLS to default to TLS 1.3, where PQC is actively being standardized, as this gives new applications the option to use PQC.
TLS Use by Other Protocols and Applications
Any new protocol that uses TLS MUST specify TLS 1.3 as its default. For example, QUIC [RFC9001] requires TLS 1.3 and specifies that endpoints MUST terminate the connection if an older version is used.
If deployment considerations are a concern, the protocol MAY specify TLS 1.2 as an additional, non-default option. As a counter example, the Usage Profile for DNS over TLS [RFC8310] specifies TLS 1.2 as the default, while also allowing TLS 1.3. For newer specifications that choose to support TLS 1.2, those preferences are to be reversed.
The initial TLS handshake allows a client to specify which versions of TLS it supports, and the server is intended to pick the highest version that it also supports. This is known as "TLS version negotiation"; protocol and negotiation details are discussed in Section 4.2.1 of [RFC9846] and Appendix E of [RFC5246]. Many TLS libraries provide a way for applications to specify the range of versions they want, including an open interval where only the lowest or highest version is specified.
If the application is using a TLS implementation that supports TLS version negotiation and if it knows that the TLS implementation will use the highest version supported, then clients SHOULD specify just the minimum version they want. This MUST be TLS 1.3 or TLS 1.2, depending on the circumstances described in the above paragraphs.
Changes to RFC 9325
[RFC9325] provides recommendations for ensuring the security of deployed services that use TLS and, unlike this document, DTLS as well. [RFC9325] describes TLS 1.3 as "widely available", and the transition to TLS 1.3 has further increased since publication of that document. This document thus makes two changes to the recommendations in Section 3.1.1 of [RFC9325]:
- That section says that TLS 1.3 SHOULD be supported; this document mandates that TLS 1.3 MUST be supported for new protocols using TLS.
- That section says that TLS 1.2 MUST be supported; this document says that TLS 1.2 MAY be supported as described above.
Again, these changes only apply to TLS, and not DTLS.
Security Considerations
TLS 1.2 was specified with several cryptographic primitives and design choices that have, over time, become significantly weaker. The purpose of this section is to briefly survey several such prominent problems that have affected the protocol. It should be noted, however, that TLS 1.2 can be configured securely; it is merely much more difficult to configure it securely as opposed to using its modern successor, TLS 1.3. See [RFC9325] for a more thorough guide on the secure deployment of TLS 1.2.
First, without any extensions, TLS 1.2 is vulnerable to renegotiation attacks (see [RENEG1] and [RENEG2]) and the Triple Handshake attack (see [TRIPLESHAKE]). Broadly, these attacks exploit the protocol's support for renegotiation in order to inject a prefix chosen by the attacker into the plaintext stream. This is usually a devastating threat in practice (e.g., it allows an attacker to obtain secret cookies in a web setting). In light of the above problems, [RFC5746] specifies an extension that prevents this category of attacks. To securely deploy TLS 1.2, either renegotiation must be disabled entirely, or this extension must be used. Additionally, clients must not allow servers to renegotiate the certificate during a connection.
Second, the original key exchange methods specified for TLS 1.2, namely RSA key exchange and finite field Diffie-Hellman, suffer from several weaknesses. To securely deploy the protocol, most of these key exchange methods must be disabled. See [I-D.ietf-tls-deprecate-obsolete-kex] for details.
Third, symmetric ciphers that are widely used in TLS 1.2, namely RC4 and Cipher Block Chaining (CBC) cipher suites, suffer from several weaknesses. RC4 suffers from exploitable biases in its key stream; see [RFC7465]. CBC cipher suites have been a source of vulnerabilities throughout the years. A straightforward implementation of these cipher suites inherently suffers from the Lucky13 timing attack [LUCKY13]. The first attempt to implement the cipher suites in constant time introduced an even more severe vulnerability [LUCKY13FIX]. Refer to [CBCSCANNING] for another example of a vulnerability with CBC cipher suites and a survey of similar works.
In addition, TLS 1.2 was affected by several other attacks that TLS 1.3 is immune to: BEAST [BEAST], Logjam [WEAKDH], FREAK [FREAK], and SLOTH [SLOTH].
Finally, while application-layer traffic in TLS 1.2 is always encrypted, most of the content of the handshake messages is not. Therefore, the privacy provided is suboptimal. This is a protocol issue that cannot be addressed by configuration.
IANA Considerations
This document has no IANA actions.
References
Normative References
[RFC9846]

The Transport Layer Security (TLS) Protocol Version 1.3
Eric Rescorla
Independent
January 2026
RFC 9846
DOI 10.17487/RFC9846
[RFC9851]

TLS 1.2 is in Feature Freeze
Rich Salz
Akamai Technologies
Nimrod Aviram
January 2026
RFC 9851
DOI 10.17487/RFC9851
Informative References
[PQC]

What Is Post-Quantum Cryptography?
NIST
June 2025
[TRIPLESHAKE]

Triple Handshakes Considered Harmful: Breaking and Fixing Authentication over TLS
Wayback Machine archive
[RENEG1]

Understanding the TLS Renegotiation Attack
Eric Rescorla
2009-11-05
Wayback Machine archive
[RENEG2]

Authentication Gap in TLS Renegotiation
Marsh Ray
Wayback Machine archive
[LUCKY13]

Lucky Thirteen: Breaking the TLS and DTLS record protocols
N. J. Al Fardan
K. G. Paterson
2013-02
[LUCKY13FIX]

Systematic Fuzzing and Testing of TLS Libraries
Juraj Somorovsky
2016-10
CCS '16: Proceedings of the 2016 ACM SIGSAC Conference on Computer and Communications Security, pp. 1492-1504
DOI 10.1145/2976749.2978411
[CBCSCANNING]

Scalable Scanning and Automatic Classification of TLS Padding Oracle Vulnerabilities
Robert Merget
Juraj Somorovsky
Nimrod Aviram
Craig Young
Janis Fliegenschmidt
Jorg Schwenk
Yuval Shavitt
2019-08
28th USENIX Security Symposium (USENIX Security 19)
[BEAST]

Here Come the XOR Ninjas
Thai Duong
Juliano Rizzo
2011-05
[WEAKDH]

Imperfect Forward Secrecy: How Diffie-Hellman Fails in Practice
D. Adrian
K. Bhargavan
Z. Durumeric
P. Gaudry
M. Green
J. A. Halderman
N. Heninger
D. Springall
E. Thome
L. Valenta
B. VanderSloot
E. Wustrow
S. Zanella-Beguelin
P. Zimmerman
2015-10
CCS '15: Proceedings of the 22nd ACM SIGSAC Conference on Computer and Communications Security, pp. 5-17
DOI 10.1145/2810103.2813707
[FREAK]

A Messy State of the Union: Taming the Composite State Machines of TLS
Benjamin Beurdouche
Karthikeyan Bhargavan
Antoine Delignat-Lavaud
Cedric Fournet
Markulf Kohlweiss
Alfredo Pironti
Pierre-Yves Strub
Jean Karim Zinzindohoue
2015-05
IEEE Symposium on Security & Privacy 2015
HAL ID: hal-01114250
[SLOTH]

Transcript Collision Attacks: Breaking Authentication in TLS, IKE, and SSH
Karthikeyan Bhargavan
Gaetan Leurent
2016-02
Network and Distributed System Security Symposium - NDSS 2016
DOI 10.14722/ndss.2016.23418
HAL ID: hal-01244855
[I-D.ietf-pquip-pqc-engineers]

Post-Quantum Cryptography for Engineers
Aritra Banerjee
Nokia
Tirumaleswar Reddy
Nokia
Dimitrios Schoinianakis
Nokia
Tim Hollebeek
DigiCert
Mike Ounsworth
Entrust Limited
25 August 2025
Internet-Draft draft-ietf-pquip-pqc-engineers-14
[RFC5246]
[RFC9325]
[RFC2119]
[RFC8174]
[RFC9001]
[RFC8310]
[RFC5746]
[I-D.ietf-tls-deprecate-obsolete-kex]
[RFC7465]